      subroutine bf2bf_5f(p,msq)
********************************************************************************
*                                                                              *
*   Author: J. Campbell, September 2014                                        *
*   Matrix elements for two-jet production                                     *
*                                                                              *
*   Note that this differs from routine qqb_2jet.f (used for direct photon     *
*   fragmentation contribution) since gg->gg matrix element is included here;  *
*   in addition, ordering of final state partons differs for some channels     *
*                                                                              *
********************************************************************************
      implicit none
      include 'constants.f'
      include 'qcdcouple.f'
      include 'sprods_com.f'
      include 'msqbits.f'
      include 'nflav.f'
      integer j,k
      double precision:: msq(-nf:nf,-nf:nf),p(mxpart,4),fac,
     &  QjQk_QjQk,AjAk_AjAk,QjAk_QjAk,AjQk_AjQk,
     &  QjQk_QkQj,AjAk_AkAj,QjAk_AkQj,AjQk_QkAj,
     &  AjQj_AkQk,QjAj_QkAk,
     &  QjQj_QjQj,AjAj_AjAj,AjQj_AjQj,QjAj_QjAj,
     &  AQ_GG,GQ_GQ,GA_GA,QG_QG,AG_AG,GG_GG,GG_QA,QA_GG,ss,tt,uu,
     &  smalla,smallb,smallc,smalld 

      call dotem(4,p,s)
      ss=s(1,2)
      tt=s(1,3)
      uu=s(2,3)

      fac=gsq**2
      
c--- four quarks
      QjQk_QjQk=fac*aveqq*smalla(ss,tt,uu)
c      write(*,*) 's=',ss,'u=',uu,'t=',tt,'smalla=',smalla(ss,tt,uu)
c      write(*,*) ss**2,uu**2,tt**2
c      write(*,*) 2*8*(ss*2+tt**2)/uu**2,smalla(ss,tt,uu)
c      write(*,*) fac,1/aveqq, AjAk_AkAj

      AjAk_AjAk=fac*aveqq*smalla(ss,tt,uu)      
c      QjAj_QkAk=fac*aveqq*smalla(tt,ss,uu)
      QjAk_QjAk=fac*aveqq*smalla(uu,tt,ss) 
c      AjQj_AkQk=fac*aveqq*smalla(tt,ss,uu)
      AjQk_AjQk=fac*aveqq*smalla(uu,tt,ss)

      QjQj_QjQj=fac*aveqq*smallb(ss,tt,uu)*half
      AjAj_AjAj=fac*aveqq*smallb(ss,tt,uu)*half
      QjAj_QjAj=fac*aveqq*smallb(uu,tt,ss)
      AjQj_AjQj=fac*aveqq*smallb(uu,tt,ss)

      QjQk_QkQj=fac*aveqq*smalla(ss,uu,tt)
      AjAk_AkAj=fac*aveqq*smalla(ss,uu,tt)
      QjAk_AkQj=fac*aveqq*smalla(ss,uu,tt)
      AjQk_QkAj=fac*aveqq*smalla(ss,uu,tt)


c--- two quarks, two gluons
      GG_QA=fac*avegg*smallc(ss,tt,uu)
      QA_GG=fac*aveqq*smallc(ss,tt,uu)*half
      AQ_GG=fac*aveqq*smallc(ss,uu,tt)*half

      QG_QG=-fac*aveqg*smallc(tt,uu,ss)
      AG_AG=-fac*aveqg*smallc(tt,uu,ss)
      GQ_GQ=-fac*aveqg*smallc(uu,tt,ss)
      GA_GA=-fac*aveqg*smallc(uu,tt,ss)

c--- four gluons
      GG_GG=fac*avegg*smalld(ss,tt,uu)*half

c--- initalize matrix elements to zero
c      msq(:,:)=0.d0

c      write(*,*) 'nflav= ', nflav
      do j=-nflav,nflav
      do k=-nflav,nflav
        msq(j,k)=0d0

      if ((j .eq. 0) .and. (k .eq. nflav)) then
        msq(j,k)=GQ_GQ
      elseif ((j .eq. 0) .and. (k .eq. -nflav)) then 
        msq(j,k)=GA_GA
      elseif ((j .eq. nflav) .and. (k .eq. 0)) then 
        msq(j,k)=QG_QG
      elseif ((j .eq.-nflav) .and. (k .eq. 0)) then 
        msq(j,k)=AG_AG

      elseif((j.eq.nflav).and.(k.gt.0).and.(k.lt.nflav)) then
        msq(j,k)=QjQk_QjQk
      elseif((j.eq.nflav).and.(k.lt.0).and.(k.gt.-nflav)) then
        msq(j,k)=QjAk_QjAk
      elseif((j.eq.-nflav).and.(k.gt.0).and.(k.lt.nflav))then
        msq(j,k)=AjQk_AjQk
      elseif((j.eq.-nflav).and.(k.lt.0).and.(k.gt.-nflav))then
        msq(j,k)=AjAk_AjAk

      elseif((j.gt.0).and.(j.lt.nflav).and.(k.eq.nflav)) then
        msq(j,k)=QjQk_QkQj
      elseif((j.lt.0).and.(j.gt.-nflav).and.(k.eq.nflav)) then
        msq(j,k)=AjQk_QkAj
      elseif((j.gt.0).and.(j.lt.nflav).and.(k.eq.-nflav))then
        msq(j,k)=QjAk_AkQj
      elseif((j.lt.0).and.(j.gt.-nflav).and.(k.eq.-nflav))then
        msq(j,k)=AjAk_AkAj

      else
        msq(j,k)=0d0
      endif
c        write(*,*)'j=',j,'k=',k, msq(j,k)

      enddo
      enddo

      return
      end



