      subroutine qqb_dirgam_v(p,msq)
      implicit none
c----Matrix element for gamma + jet production
c----in order alpha_s^2
C----averaged over initial colours and spins
c     q(-p1)+qbar(-p2)-->gamma(p3)+f(p4)
c---
      include 'constants.f'
      include 'ewcouple.f'
      include 'ewcharge.f'
      include 'qcdcouple.f'
      include 'sprods_com.f'
      include 'scheme.f'
      double precision qa,aq,qg,ag,gq,ga
      double precision msq(-nf:nf,-nf:nf),p(mxpart,4),fac,qaggam
      integer j,k
      double precisiontest,gamamp_qqbg,test1,test2,test3
      fac=4d0*V*gsq*esq*ason2pi

      scheme='tH-V'

      call dotem(4,p,s)
      qa=+qaggam(1,2,4)*fac*aveqq
c      aq=+qaggam(2,1,4)*fac*aveqq
      aq=qa
      qg=-qaggam(1,4,2)*fac*aveqg
c      ag=-qaggam(4,1,2)*fac*aveqg
      ag=qg

      gq=-qaggam(2,4,1)*fac*aveqg
c      ga=-qaggam(4,2,1)*fac*aveqg
      ga=gq

      do j=-nf,nf
      do k=-nf,nf
c--set msq=0 to initalize
      msq(j,k)=0d0
C--qa      
      if ((j > 0) .and. (k < 0)) then
          if (j == -k) msq(j,k)=Q(j)**2*qa
C--aq      
      elseif ((j < 0) .and. (k > 0)) then
          if (j == -k) msq(j,k)=Q(k)**2*aq
C--qg
      elseif ((j > 0) .and. (k == 0)) then
            msq(j,k)=Q(j)**2*qg
C--ag      
      elseif ((j < 0) .and. (k == 0)) then
            msq(j,k)=Q(j)**2*ag
C--gq
      elseif ((j == 0) .and. (k > 0)) then
            msq(j,k)=Q(k)**2*gq
C--ga      
      elseif ((j == 0) .and. (k < 0)) then
            msq(j,k)=Q(-k)**2*ga
      endif

      enddo
      enddo

      return
      end

      function qaggam(i1,i2,i3)
      implicit none
      double precision qaggam
      
c----Matrix element for gamma + jet production
c----in order alpha_s^2
C----averaged over initial colours and spins
c     q(-p1)+qbar(-p2)-->g(p3)+gamma(p4)
c---
C---- Matrix element derived from ERT
C---- %\cite{Ellis:1980wv}
C---- \bibitem{Ellis:1980wv}
C---- R.~K.~Ellis, D.~A.~Ross and A.~E.~Terrano,
C---- %``The Perturbative Calculation Of Jet Structure In E+ E- Annihilation,''
C---- Nucl.\ Phys.\ B {\bf 178}, 421 (1981).
C---- %%CITATION = NUPHA,B178,421;%%

C---- Matrix element also checked from Eq. (2.28)
C---- %\cite{Aurenche:1986ff}
C---- \bibitem{Aurenche:1986ff}
C---- P.~Aurenche, R.~Baier, A.~Douiri, M.~Fontannaz and D.~Schiff,
C---- %``Scheme Invariant Higher Order QCD Predictions For Large P(T)
C---- Photoproduction Reactions,''
C---- Nucl.\ Phys.\ B {\bf 286}, 553 (1987).
C---- %%CITATION = NUPHA,B286,553;%%
      include 'constants.f'
      include 'sprods_com.f'
      include 'epinv.f'
      include 'scale.f'
      include 'scheme.f'
      integer i1,i2,i3
      double complex lnrat,l12,l13,l23
      double precision s12,s13,s23,T0,deltar

      s12=s(i1,i2)
      s13=s(i1,i3)
      s23=s(i2,i3)
      T0=s13/s23+s23/s13
      l12=lnrat(-s12,musq)
      l13=lnrat(-s13,musq)
      l23=lnrat(-s23,musq)

      if     (scheme == 'tH-V') then
        deltar=0d0
      elseif (scheme == 'dred') then
        deltar=1d0
      else
        write(6,*) 'Invalid scheme in qqb_gamgam_v.f'
        stop
      endif
      
      qaggam=-(2d0*xn-1d0/xn)*(epinv**2-pisq/six)*T0
     & -epinv*(3d0*cf-2d0*cf*real(l12)+xn*real(l12-l13-l23)
     &  +11d0*xn/6d0-nf/3d0)*T0
     & +((xn-cf)*pisq/3d0-7d0*cf+deltar*(cf+xn/6d0)-cf*real(l12**2)
     & +xn*(0.5d0*real(l12**2)-real(l13*l23)))*T0
     & +real(l13)*(cf*(s23-2d0*s12)/s13-xn)
     & +real(l23)*(cf*(s13-2d0*s12)/s23-xn)
     & -((s12**2+s23**2)/s13/s23*(real((l12-l23)**2)+pisq)
     &  +(s12**2+s13**2)/s13/s23*(real((l12-l13)**2)+pisq)
     &  -4d0*real(l12))/(2d0*xn)
      return 
      end


