      subroutine scaleset_ET3(p,mu0)
c--- subroutine to calculate dynamic scale equal to
c--- partonic MT (i.e. scalar sum of particle pt's, whether or not they pass cuts)
      implicit none
      include 'constants.f'
      include 'npart.f'
      include 'process.f'
      include 'masses.f'
      integer j
      double precision p(mxpart,4),mu0,pt,ptcut
      double precision HT3, HT4

      mu0=0d0
      do j=3,npart+2
      mu0=mu0+dsqrt(p(j,4)**2-p(j,3)**2)
      enddo

      pt=dsqrt(p(3,1)**2+p(3,2)**2)

      if (case.eq.'bfbf5f'.or.case.eq.'bb_tot')then
        mu0=dsqrt(pt**2+mb**2)
        ptcut=40.d0
      elseif (case.eq.'cfcf4f'.or.case.eq.'cc_tot') then
        mu0=dsqrt(pt**2+mc**2)
        ptcut=8.d0
      endif

      !if(pt>ptcut) print'(a,4es11.2)','mc,mb,pt,mu ', mc,mb, pt, mu0

      return
      end 

      subroutine scaleset_MT312(p,mu0)
c--- subroutine to calculate dynamic scale equal to
c--- partonic MT (i.e. scalar sum of particle pt's, whether or not they pass cuts)
      implicit none
      include 'constants.f'
      include 'npart.f'
      include 'process.f'
      include 'masses.f'
      integer j
      double precision p(mxpart,4),mu0,pt,ptcut
      double precision HT3, HT4

      mu0=0d0
      do j=3,npart+2
      mu0=mu0+dsqrt(p(j,4)**2-p(j,3)**2)
      enddo

      pt=dsqrt(p(3,1)**2+p(3,2)**2)

      if (case.eq.'bfbf5f'.or.case.eq.'bb_tot')then
        mu0=dsqrt(pt**2+4*mb**2)
        ptcut=40.d0
      elseif (case.eq.'cfcf4f'.or.case.eq.'cc_tot') then
        mu0=dsqrt(pt**2+4*mc**2)
        ptcut=8.d0
      endif

      !if(pt>ptcut) print'(a,4es11.2)','mc,mb,pt,mu ', mc,mb, pt, mu0

      return
      end

      subroutine scaleset_MT3h2(p,mu0)
c--- subroutine to calculate dynamic scale equal to
c--- partonic MT (i.e. scalar sum of particle pt's, whether or not they pass cuts)
      implicit none
      include 'constants.f'
      include 'npart.f'
      include 'process.f'
      include 'masses.f'
      integer j 
      double precision p(mxpart,4),mu0,pt,ptcut
      double precision HT3, HT4

      mu0=0d0
      do j=3,npart+2
      mu0=mu0+dsqrt(p(j,4)**2-p(j,3)**2)
      enddo

      pt=dsqrt(p(3,1)**2+p(3,2)**2)    

      if (case.eq.'bfbf5f'.or.case.eq.'bb_tot')then
        mu0=dsqrt(pt**2/4.0+4*mb**2)
        ptcut=40.d0
      elseif (case.eq.'cfcf4f'.or.case.eq.'cc_tot') then
        mu0=dsqrt(pt**2/4.0+4*mc**2)
        ptcut=8.d0
      endif

      !if(pt>ptcut) print'(a,4es11.2)','mc,mb,pt,mu ', mc,mb, pt, mu0

      return
      end
      
      
