*****************
* LHAPDF version*
*****************
      module split_fns
       implicit none
      contains

      function xPqg_correct(y) result(res)
      use types
      use convolution_communicator
       real(dp), intent(in) :: y
       real(dp)             :: res
       real(dp)             :: x
         x = exp(-y)
         res = 0.0_dp

       select case(cc_piece)
       case(cc_REAL,cc_REALVIRT)
         res = 0.5_dp*(x**2 + (1.0_dp-x)**2)
       end select
       select case(cc_piece)
       case(cc_VIRT,cc_REALVIRT)
        ! a line that does nothing...
        !res = res - 0.0_dp
       case(cc_DELTA)
         res = 0.0_dp
       end select

       if (cc_piece /= cc_DELTA) res = res * x
      end function xPqg_correct
      end module split_fns

      subroutine fdist_res(ih,x,xmu,fx)
      use split_fns
      use types
      use hoppet_v1, EvolvePDF_hoppet => EvolvePDF,
     $       InitPDF_hoppet => InitPDF
      implicit none
      include 'process.f'
      include 'masses.f'
      double precision fx(-5:5),x,xmu,fPDF(-6:6)
      integer Iprtn,ih,Irt,i,nproc,exptid
      real(8)::xgluon_PDF,alphas,fac,alphasPDF
      real(8):: y, Q, xgluon_at_y, xf(-6:6), bsub, xg0
      type(grid_def) :: grid
      type(grid_conv):: xPqg
      real(8), pointer :: xgluon(:), xvals(:), xPqg_x_xgluon(:)
      common/nproc/nproc
      common/exptid/exptid
c      double precision :: sqrts
c      common/energy/sqrts
c      real(8), parameter :: pi = acos(-1._dp)
c---  ih1=+1 proton 
c---  ih1=-1 pbar 

      y=-dlog(x)
      Q=xmu

      call InitGridDef(grid,dy=0.2_dp,ymax=20.0_dp,order=5)
      call AllocGridConv(grid,xPqg)
      call InitGridConv(grid,xPqg, xPqg_correct)
      call AllocGridQuant(grid,xPqg_x_xgluon)

      call AllocGridQuant(grid,xgluon)
      call AllocGridQuant(grid,xvals)
           xvals=xValues(grid)
c      call InitPDFsetByName("CT14nnlo")
c      call InitPDF(0)
      do i=0, size(xvals)-1
         call evolvePDF(xvals(i),Q,xf)
         xgluon(i)=xf(0)
      enddo

      xPqg_x_xgluon = (xPqg .conv. xgluon)
      alphas=alphasPDF(Q)
  
c      write(*,*) 'x=',x, 'Q=', Q, 'alphaS=', alphas, 'mb=', mb
      fac=alphas/(2*pi)*dlog(Q**2/mb**2)
      bsub=EvalGridQuant(grid,xPqg_x_xgluon,y)*fac
      xg0=EvalGridQuant(grid,xgluon,y)
      deallocate(xvals,xgluon,xPqg_x_xgluon)
c      write(*,*)'xg=', xf(0), 'Init', xg0, 'xbsub=', bsub
C---set to zero if x out of range
      if (x .ge. 1d0) then
          do Iprtn=-5,5
             fx(Iprtn)=0d0
          enddo
          return
      endif

      call evolvePDF(x,xmu,fPDF)
      if (ih.eq.1) then
        do Iprtn=-5,5
          fx(+Iprtn)=fPDF(+Iprtn)/x
        enddo
      elseif(ih.eq.-1) then
        do Iprtn=-5,5
          fx(+Iprtn)=fPDF(-Iprtn)/x
        enddo
      endif
c      if(mod(exptid,10).eq.1) then
          fx( 5)=(fPDF( 5)-bsub)/x
          fx(-5)=(fPDF(-5)-bsub)/x
c      elseif(mod(exptid,10).eq.2) then
c           fx( 5)=bsub/x
c           fx(-5)=bsub/x
c      endif
                     
      return
      end
