      logical function gencuts(pjet,njets)
************************************************************************
*   Author: J.M. Campbell, 26th November 2013                          *
*                                                                      *
*   This routine calls specific cutting routines if requested,         *
*   otherwise just uses the cuts specified in the input file           *
*                                                                      *
************************************************************************
      implicit none
      include 'constants.f'
      include 'process.f'
      include 'runstring.f'
      include 'masses.f'
      logical failed,gencuts_Zt,gencuts_WZjj,gencuts_input
      integer njets,nproc,exptid
      double precision, external:: geteta, getrap
      double precision pjet(mxpart,4)
      double precision p1ll,p2ll,p3ll,p0ll,ptll,yll, ptcut
      double precision pt3,pt4,pplus,pminus,y3,y4,s34,pt34,y34
      common/nproc/nproc
      common/exptid/exptid
      gencuts=.false.
      
c      if ( (case .eq. 'HZZ_4l')
c     & .or.(case .eq. 'HZZ_tb')
c     & .or.(case .eq. 'HZZint')
c     & .or.(case .eq. 'HZZH+i')
c     & .or.(case .eq. 'ggZZ4l') 
c     & .or.(case .eq. 'HZZqgI')) then 
c        call CMS_hzz(pjet,failed)
c        if (failed) gencuts=.true.
c        return
c      endif

c      if ( (case .eq. 'HWW_4l')
c     & .or.(case .eq. 'HWW_tb')
c     & .or.(case .eq. 'HWWint')
c     & .or.(case .eq. 'HWWH+i')
c     & .or.(case .eq. 'ggWW4l') 
c     & .or.(case .eq. 'WWqqbr')) then 
c        call ATLAS_hww2013(pjet,failed)
c        if (failed) gencuts=.true.
c        return
c      endif

c -- CMS FCNC cuts for Z_tdkj
c      if ( case .eq. 'Z_tdkj' .and. runstring(1:3) .eq. 'CMS' ) then
c         gencuts=gencuts_Zt(pjet,njets)
c         return
c      endif

c      if ( case .eq. 'WpmZjj' .and. runstring(1:3) .eq. 'CMS' ) then
c         gencuts=gencuts_WZjj(pjet,njets)
c         return
c      endif

c--- Default: use the cuts from the input file
!    The input cuts will always be imposed

        gencuts=gencuts_input(pjet,njets)

!  We impose additional cuts for the following process
c xkp May17 2018
c cut for LHCb, cut oneside
      if(exptid.eq.15) then
         y4=getrap(pjet(4,4), pjet(4,3))
         if(y4.lt.0) gencuts=.true.
      endif
      if(exptid.eq.65) then
         y3=getrap(pjet(3,4), pjet(3,3))
         if(y3.lt.0) gencuts=.true.
      endif
      if(exptid.eq.315) then
         y3=getrap(pjet(3,4), pjet(3,3))
         y4=getrap(pjet(4,4), pjet(4,3))
         if(y3.lt.0 .or. y4.lt.0) gencuts=.true.
      endif

c  Keping Xie, Nov 29, 2016
c  cut for CMS8ZpT 1504.03511
      if(nproc.eq.41) then
        p1ll=pjet(3,1)+pjet(4,1)
        p2ll=pjet(3,2)+pjet(4,2)
        p3ll=pjet(3,3)+pjet(4,3)
        p0ll=pjet(3,4)+pjet(4,4)

        ptll=dsqrt(p1ll**2+p2ll**2)
        yll=(p0ll+p3ll)/(p0ll-p3ll)
        if(yll .lt. 1d-13) then
          yll=100d0
        else 
          yll=0.5d0*dlog(yll)
        endif
c CMS8ZpT
       if(exptid.eq.411) then 
         if(abs(yll).gt.0.4d0) then
         gencuts=.true.
         endif 
       elseif(exptid.eq.412) then
         if(abs(yll).lt.0.4d0.or.abs(yll).gt.0.8d0) then
         gencuts=.true.
         endif 
       elseif(exptid.eq.413) then
         if(abs(yll).lt.0.8d0.or.abs(yll).gt.1.2d0) then
         gencuts=.true.
         endif
       elseif(exptid.eq.414) then
         if(abs(yll).lt.1.2d0.or.abs(yll).gt.1.6d0) then
         gencuts=.true.
         endif
       elseif(exptid.eq.415) then
         if(abs(yll).lt.1.6d0.or.abs(yll).gt.2.0d0) then
         gencuts=.true.
         endif
c  ATLAS8 ZpT
       elseif(exptid.eq.416.or.(exptid.ge.4161.and.exptid.le.4166))then
         if(ptll.lt.30) then
         gencuts=.true.
         endif
         if(abs(yll).gt.2.4d0) then
         gencuts=.true.
         endif
         if(exptid.eq.4161) then
           if(abs(yll).gt.0.4d0) then
           gencuts=.true.
           endif
         elseif(exptid.eq.4162) then
           if(abs(yll).lt.0.4d0.or.abs(yll).gt.0.8d0) then
           gencuts=.true.
           endif
         elseif(exptid.eq.4163) then
           if(abs(yll).lt.0.8d0.or.abs(yll).gt.1.2d0) then
           gencuts=.true.
           endif
         elseif(exptid.eq.4164) then
           if(abs(yll).lt.1.2d0.or.abs(yll).gt.1.6d0) then
           gencuts=.true.
           endif
         elseif(exptid.eq.4165) then
           if(abs(yll).lt.1.6d0.or.abs(yll).gt.2.0d0) then
           gencuts=.true.
           endif
         elseif(exptid.eq.4166) then
           if(abs(yll).lt.2.0d0.or.abs(yll).gt.2.4d0) then
           gencuts=.true.
           endif
         endif !end(exptid.eq.416x)
       endif! end(exptid.eq.41x)

c LHCb bbx production
      elseif(nproc.eq.158.or.case.eq.'bfbf5f'.or.
     &       nproc.eq.159.or.case.eq.'cfcf4f') then
      pt3=sqrt(pjet(3,1)**2+pjet(3,2)**2)
      pt4=sqrt(pjet(4,1)**2+pjet(4,2)**2)
      y3=getrap(pjet(3,4),pjet(3,3))
      y4=getrap(pjet(4,4),pjet(4,3))

        if(nproc.eq.158.or.case.eq.'bfbf5f') ptcut=40.d0
        ! LHCb7TeV D-meson pTc<8GeV; 13TeV pTc<15GeV
        if(nproc.eq.159.or.case.eq.'cfcf4f') ptcut=15.0d0
      ! we only require pt3&&y3-> mu=ET3
      ! for QQb-pair, we need apply symmetry 3<->4

      if(pt3>ptcut) then
        gencuts=.true.
        return
      endif

       if(mod(exptid,10).eq.1) then
        if(abs(y3).lt.2.0.or.abs(y3).gt.4.5) gencuts=.true.

       elseif(mod(exptid,10).eq.2) then
        if(abs(y3).lt.2.0.or.abs(y3).gt.2.5) gencuts=.true.

       elseif(mod(exptid,10).eq.3) then
        if(abs(y3).lt.2.5.or.abs(y3).gt.3.0) gencuts=.true.

       elseif(mod(exptid,10).eq.4) then
        if(abs(y3).lt.3.0.or.abs(y3).gt.3.5) gencuts=.true.

       elseif(mod(exptid,10).eq.5) then
        if(abs(y3).lt.3.5.or.abs(y3).gt.4.0) gencuts=.true.

       elseif(mod(exptid,10).eq.6) then
        if(abs(y3).lt.4.0.or.abs(y3).gt.4.5) gencuts=.true.

       endif  !exptid

      endif ! nproc
       
      return
      end
 
      function geteta(p1, p2, p3) result(eta)
      implicit none
      double precision p1, p2, p3, mom, eta

        mom=dsqrt(p1**2+p2**2+p3**2)
        eta=(mom+p3)/(mom-p3)
        if(eta .lt. 1d-13) then
          eta=100d0
        else
          eta=0.5d0*dlog(eta)
        endif

      end function
 
      function getrap(p0, p3) result(rap)
      implicit none
      double precision p0, p3, rap

        rap=(p0+p3)/(p0-p3)
        if(rap .lt. 1d-13) then
          rap=100d0
        else
          rap=0.5d0*dlog(rap)
        endif

      end function

 
